#!/usr/bin/perl
###############################################################################
#                                                                             #
# IPFire.org - A linux based firewall                                         #
# Copyright (C) 2012  											              #
#                                                                             #
# This program is free software: you can redistribute it and/or modify        #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation, either version 3 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.       #
#                                                                             #
###############################################################################
#																			  #
# Hi folks! I hope this code is useful for all. I needed something to handle  #
# my VPN Connections in a comfortable way. As a prerequisite i needed 		  #
# something that makes sure the vpn roadwarrior are able to have a fixed 	  #
# ip-address. So i developed the ccd extension for the vpn server.			  #
# 																			  #
# Now that the ccd extension is ready i am able to develop the main request.  #
# Any feedback is appreciated.												  #
#																			  #
#																			  #
###############################################################################

use strict;
no warnings 'uninitialized';
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';

require '/var/ipfire/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my %fwdfwsettings=();
my %selected=() ;
my %defaultNetworks=();
my %netsettings=();
my %customhost=();
my %customgrp=();
my %customnetworks=();
my %customservice=();
my %customservicegrp=();
my %ccdnet=();
my %customnetwork=();
my %ccdhost=();
my %configfwdfw=();
my %ipsecconf=();
my %color=();
my %mainsettings=();
my %checked=();
my %icmptypes=();
my %ovpnsettings=();
my $color;
my $confignet		= "${General::swroot}/fwhosts/customnetworks";
my $confighost		= "${General::swroot}/fwhosts/customhosts";
my $configgrp 		= "${General::swroot}/fwhosts/customgroups";
my $configsrv 		= "${General::swroot}/fwhosts/customservices";
my $configsrvgrp	= "${General::swroot}/fwhosts/customservicegrp";
my $configccdnet 	= "${General::swroot}/ovpn/ccd.conf";
my $configccdhost	= "${General::swroot}/ovpn/ovpnconfig";
my $configipsec		= "${General::swroot}/vpn/config";
my $configfwdfw		= "${General::swroot}/forward/config";
my $configovpn		= "${General::swroot}/ovpn/settings";
my $errormessage='';
my $ipgrp="${General::swroot}/outgoing/groups";
unless (-d "${General::swroot}/forward") 			{ system("mkdir ${General::swroot}/forward"); }
unless (-e "${General::swroot}/forward/settings")   { system("touch ${General::swroot}/forward/settings"); }
unless (-e "${General::swroot}/forward/config")  	{ system("touch ${General::swroot}/forward/config"); }

&General::readhash("${General::swroot}/forward/settings", \%fwdfwsettings);
&General::readhash("${General::swroot}/main/settings", \%mainsettings);
&General::readhash("/srv/web/ipfire/html/themes/".$mainsettings{'THEME'}."/include/colors.txt", \%color);
&Header::getcgihash(\%fwdfwsettings);
&Header::showhttpheaders();
&Header::openpage($Lang::tr{'fwdfw menu'}, 1, '');
&Header::openbigbox('100%', 'center',$errormessage);

####  ACTION  #####

if ($fwdfwsettings{'ACTION'} eq $Lang::tr{'save'})
{
	my $MODE = $fwdfwsettings{'POLICY'};
	%fwdfwsettings = ();
	$fwdfwsettings{'POLICY'} = "$MODE";
	&General::writehash("${General::swroot}/forward/settings", \%fwdfwsettings);
	#system("/usr/local/bin/outgoingfwctrl");
}
if ($fwdfwsettings{'ACTION'} eq 'saverule')
{
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	$errormessage=&checksource;
	if(!$errormessage){&checktarget;}
	if(!$errormessage){&checkrule;}
	#check if we have an identical rule already
	foreach my $key (sort keys %configfwdfw){
				
		if ("$fwdfwsettings{'RULE_ACTION'},$fwdfwsettings{'ACTIVE'},$fwdfwsettings{'grp1'},$fwdfwsettings{$fwdfwsettings{'grp1'}},$fwdfwsettings{'grp2'},$fwdfwsettings{$fwdfwsettings{'grp2'}},$fwdfwsettings{'USE_SRC_PORT'},$fwdfwsettings{'PROT'},$fwdfwsettings{'ICMP_TYPES'},$fwdfwsettings{'SRC_PORT'},$fwdfwsettings{'USESRV'},$fwdfwsettings{'TGT_PROT'},$fwdfwsettings{'ICMP_TGT'},$fwdfwsettings{'grp3'},$fwdfwsettings{$fwdfwsettings{'grp3'}},$fwdfwsettings{'ruleremark'},$fwdfwsettings{'LOG'},$fwdfwsettings{'TIME'},$fwdfwsettings{'TIME_MON'},$fwdfwsettings{'TIME_TUE'},$fwdfwsettings{'TIME_WED'},$fwdfwsettings{'TIME_THU'},$fwdfwsettings{'TIME_FRI'},$fwdfwsettings{'TIME_SAT'},$fwdfwsettings{'TIME_SUN'},$fwdfwsettings{'TIME_FROM'},$fwdfwsettings{'TIME_TO'}" 
			eq "$configfwdfw{$key}[0],$configfwdfw{$key}[2],$configfwdfw{$key}[3],$configfwdfw{$key}[4],$configfwdfw{$key}[5],$configfwdfw{$key}[6],$configfwdfw{$key}[7],$configfwdfw{$key}[8],$configfwdfw{$key}[9],$configfwdfw{$key}[10],$configfwdfw{$key}[11],$configfwdfw{$key}[12],$configfwdfw{$key}[13],$configfwdfw{$key}[14],$configfwdfw{$key}[15],$configfwdfw{$key}[16],$configfwdfw{$key}[17],$configfwdfw{$key}[18],$configfwdfw{$key}[19],$configfwdfw{$key}[20],$configfwdfw{$key}[21],$configfwdfw{$key}[22],$configfwdfw{$key}[23],$configfwdfw{$key}[24],$configfwdfw{$key}[25],$configfwdfw{$key}[26],$configfwdfw{$key}[27]"){
				$errormessage.=$Lang::tr{'fwdfw err ruleexists'};
		}		
	}	
	
	
	#print "Source: $fwdfwsettings{'grp1'} -> $fwdfwsettings{$fwdfwsettings{'grp1'}}<br>";
	#print "Sourceport: $fwdfwsettings{'USE_SRC_PORT'}, $fwdfwsettings{'PROT'}, $fwdfwsettings{'ICMP_TYPES'}, $fwdfwsettings{'SRC_PORT'}<br>";
	#print "Target: $fwdfwsettings{'grp2'} -> $fwdfwsettings{$fwdfwsettings{'grp2'}}<br>";
	#print "Dienst:  $fwdfwsettings{'USESRV'}, $fwdfwsettings{'grp3'} -> $fwdfwsettings{$fwdfwsettings{'grp3'}}<br>";
	#print "BEMERKUNG: $fwdfwsettings{'ruleremark'}<br>";
	#print " Regel AKTIV: $fwdfwsettings{'ACTIVE'}<br>";
	#print " Regel LOG: $fwdfwsettings{'LOG'}<br>";
	#print " ZEITRAHMEN: $fwdfwsettings{'TIME'}<br>";
	#print " MO: $fwdfwsettings{'TIME_MON'}<br>";
	#print " DI: $fwdfwsettings{'TIME_TUE'}<br>";
	#print " MI: $fwdfwsettings{'TIME_WED'}<br>";
	#print " DO: $fwdfwsettings{'TIME_THU'}<br>";
	#print " FR: $fwdfwsettings{'TIME_FRI'}<br>";
	#print " SA: $fwdfwsettings{'TIME_SAT'}<br>";
	#print " SO: $fwdfwsettings{'TIME_SUN'}<br>";
	#print " VON: $fwdfwsettings{'TIME_FROM'} bis $fwdfwsettings{'TIME_TO'}<br>";
	#print "<br>";
	#print"ALT: $fwdfwsettings{'oldgrp1a'} $fwdfwsettings{'oldgrp1b'}	NEU:	$fwdfwsettings{'grp1'} $fwdfwsettings{$fwdfwsettings{'grp1'}}<br>";
	#print"ALT: $fwdfwsettings{'oldgrp2a'} $fwdfwsettings{'oldgrp2b'}	NEU:	$fwdfwsettings{'grp2'} $fwdfwsettings{$fwdfwsettings{'grp2'}}<br>";
	#print"ALT: $fwdfwsettings{'oldgrp3a'} $fwdfwsettings{'oldgrp3b'}	NEU:	$fwdfwsettings{'grp3'} $fwdfwsettings{$fwdfwsettings{'grp3'}}<br>";
	
	#increase counters
	&checkcounter($fwdfwsettings{'oldgrp1a'},$fwdfwsettings{'oldgrp1b'},$fwdfwsettings{'grp1'},$fwdfwsettings{$fwdfwsettings{'grp1'}});
	&checkcounter($fwdfwsettings{'oldgrp2a'},$fwdfwsettings{'oldgrp2b'},$fwdfwsettings{'grp2'},$fwdfwsettings{$fwdfwsettings{'grp2'}});
	&checkcounter($fwdfwsettings{'oldgrp3a'},$fwdfwsettings{'oldgrp3b'},$fwdfwsettings{'grp3'},$fwdfwsettings{$fwdfwsettings{'grp3'}});
	
	
	if (!$errormessage){
		if ($fwdfwsettings{'updatefwrule'} ne 'on' ){
			my $key = &General::findhasharraykey (\%configfwdfw);
			$configfwdfw{$key}[0]  = $fwdfwsettings{'RULE_ACTION'};
			$configfwdfw{$key}[1]  = "FORWARD";
			$configfwdfw{$key}[2]  = $fwdfwsettings{'ACTIVE'};
			$configfwdfw{$key}[3]  = $fwdfwsettings{'grp1'};
			$configfwdfw{$key}[4]  = $fwdfwsettings{$fwdfwsettings{'grp1'}};
			$configfwdfw{$key}[5]  = $fwdfwsettings{'grp2'};
			$configfwdfw{$key}[6]  = $fwdfwsettings{$fwdfwsettings{'grp2'}};
			$configfwdfw{$key}[7]  = $fwdfwsettings{'USE_SRC_PORT'};
			$configfwdfw{$key}[8]  = $fwdfwsettings{'PROT'};
			$configfwdfw{$key}[9]  = $fwdfwsettings{'ICMP_TYPES'};
			$configfwdfw{$key}[10] = $fwdfwsettings{'SRC_PORT'};
			$configfwdfw{$key}[11] = $fwdfwsettings{'USESRV'};
			$configfwdfw{$key}[12] = $fwdfwsettings{'TGT_PROT'};
			$configfwdfw{$key}[13] = $fwdfwsettings{'ICMP_TGT'};
			$configfwdfw{$key}[14] = $fwdfwsettings{'grp3'};
			$configfwdfw{$key}[15] = $fwdfwsettings{$fwdfwsettings{'grp3'}};
			$configfwdfw{$key}[16] = $fwdfwsettings{'ruleremark'};
			$configfwdfw{$key}[17] = $fwdfwsettings{'LOG'};
			$configfwdfw{$key}[18] = $fwdfwsettings{'TIME'};
			$configfwdfw{$key}[19] = $fwdfwsettings{'TIME_MON'};
			$configfwdfw{$key}[20] = $fwdfwsettings{'TIME_TUE'};
			$configfwdfw{$key}[21] = $fwdfwsettings{'TIME_WED'};
			$configfwdfw{$key}[22] = $fwdfwsettings{'TIME_THU'};
			$configfwdfw{$key}[23] = $fwdfwsettings{'TIME_FRI'};
			$configfwdfw{$key}[24] = $fwdfwsettings{'TIME_SAT'};
			$configfwdfw{$key}[25] = $fwdfwsettings{'TIME_SUN'};
			$configfwdfw{$key}[26] = $fwdfwsettings{'TIME_FROM'};
			$configfwdfw{$key}[27] = $fwdfwsettings{'TIME_TO'};
			&General::writehasharray("$configfwdfw", \%configfwdfw);
		}else{
			foreach my $key (sort keys %configfwdfw){
				if($key eq $fwdfwsettings{'key'}){
					$configfwdfw{$key}[0]  = $fwdfwsettings{'RULE_ACTION'};
					$configfwdfw{$key}[1]  = "FORWARD";
					$configfwdfw{$key}[2]  = $fwdfwsettings{'ACTIVE'};
					$configfwdfw{$key}[3]  = $fwdfwsettings{'grp1'};
					$configfwdfw{$key}[4]  = $fwdfwsettings{$fwdfwsettings{'grp1'}};
					$configfwdfw{$key}[5]  = $fwdfwsettings{'grp2'};
					$configfwdfw{$key}[6]  = $fwdfwsettings{$fwdfwsettings{'grp2'}};
					$configfwdfw{$key}[7]  = $fwdfwsettings{'USE_SRC_PORT'};
					$configfwdfw{$key}[8]  = $fwdfwsettings{'PROT'};
					$configfwdfw{$key}[9]  = $fwdfwsettings{'ICMP_TYPES'};
					$configfwdfw{$key}[10] = $fwdfwsettings{'SRC_PORT'};
					$configfwdfw{$key}[11] = $fwdfwsettings{'USESRV'};
					$configfwdfw{$key}[12] = $fwdfwsettings{'TGT_PROT'};
					$configfwdfw{$key}[13] = $fwdfwsettings{'ICMP_TGT'};
					$configfwdfw{$key}[14] = $fwdfwsettings{'grp3'};
					$configfwdfw{$key}[15] = $fwdfwsettings{$fwdfwsettings{'grp3'}};
					$configfwdfw{$key}[16] = $fwdfwsettings{'ruleremark'};
					$configfwdfw{$key}[17] = $fwdfwsettings{'LOG'};
					$configfwdfw{$key}[18] = $fwdfwsettings{'TIME'};
					$configfwdfw{$key}[19] = $fwdfwsettings{'TIME_MON'};
					$configfwdfw{$key}[20] = $fwdfwsettings{'TIME_TUE'};
					$configfwdfw{$key}[21] = $fwdfwsettings{'TIME_WED'};
					$configfwdfw{$key}[22] = $fwdfwsettings{'TIME_THU'};
					$configfwdfw{$key}[23] = $fwdfwsettings{'TIME_FRI'};
					$configfwdfw{$key}[24] = $fwdfwsettings{'TIME_SAT'};
					$configfwdfw{$key}[25] = $fwdfwsettings{'TIME_SUN'};
					$configfwdfw{$key}[26] = $fwdfwsettings{'TIME_FROM'};
					$configfwdfw{$key}[27] = $fwdfwsettings{'TIME_TO'};
					
					last;
				}
			}
			&General::writehasharray("$configfwdfw", \%configfwdfw);
		}
	}
	if ($errormessage){
		&newrule;
	}else{
		&base;
	}
}
if ($fwdfwsettings{'ACTION'} eq $Lang::tr{'reset'})
{
	$fwdfwsettings{'POLICY'}='MODE0';
	my $MODE = $fwdfwsettings{'POLICY'};
	system("rm ${General::swroot}/forward/config");
	%fwdfwsettings = ();
	$fwdfwsettings{'POLICY'} = "$MODE";
	&General::writehash("${General::swroot}/forward/settings", \%fwdfwsettings);
	
}
if ($fwdfwsettings{'ACTION'} eq $Lang::tr{'fwdfw newrule'})
{
	&newrule;
}
if ($fwdfwsettings{'ACTION'} eq $Lang::tr{'fwdfw toggle'})
{
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	foreach my $key (sort keys %configfwdfw){
		if ($key eq $fwdfwsettings{'key'}){
			if ($configfwdfw{$key}[2] eq 'ON'){$configfwdfw{$key}[2]='';}else{$configfwdfw{$key}[2]='ON';}
		}
	}
	&General::writehasharray("$configfwdfw", \%configfwdfw);
	&base;
}
if ($fwdfwsettings{'ACTION'} eq $Lang::tr{'fwdfw togglelog'})
{
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	foreach my $key (sort keys %configfwdfw){
		if ($key eq $fwdfwsettings{'key'}){
			if ($configfwdfw{$key}[17] eq 'ON'){$configfwdfw{$key}[17]='';}else{$configfwdfw{$key}[17]='ON';}
		}
	}
	&General::writehasharray("$configfwdfw", \%configfwdfw);
	&base;
}
if ($fwdfwsettings{'ACTION'} eq 'editrule')
{
	$fwdfwsettings{'updatefwrule'}='on';
	&newrule;
}
if ($fwdfwsettings{'ACTION'} eq 'deleterule')
{
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	foreach my $key (sort keys %configfwdfw){
		if ($key ge $fwdfwsettings{'key'}) {
			my $next = $key + 1;
			
			&checkcounter($configfwdfw{$key}[3],$configfwdfw{$key}[4],,);
			&checkcounter($configfwdfw{$key}[5],$configfwdfw{$key}[6],,);
			
			if (exists $configfwdfw{$next}) {
				foreach my $i (0 .. $#{$configfwdfw{$next}}) {
					$configfwdfw{$key}[$i] = $configfwdfw{$next}[$i];
				}
			}
		}
	}
	# Remove the very last entry.
	my $last_key = (sort keys %configfwdfw)[-1];
	delete $configfwdfw{$last_key};

	&General::writehasharray("$configfwdfw", \%configfwdfw);
	&base;
}
if ($fwdfwsettings{'ACTION'} eq 'moveup')
{
	&pos_up;
	&base;
}
if ($fwdfwsettings{'ACTION'} eq 'movedown')
{
	&pos_down;
	&base;
}
if ($fwdfwsettings{'ACTION'} eq 'copyrule')
{
	$fwdfwsettings{'copyfwrule'}='on';
	#$fwdfwsettings{'updatefwrule'}='on';
	&newrule;
}
if ($fwdfwsettings{'ACTION'} eq '')
{
	&base;
}
###  Functions  ####
sub pos_up
{
	my %tmp=();
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	foreach my $key (sort keys %configfwdfw){
		if ($key eq $fwdfwsettings{'key'}) {
			my $last = $key -1;
			if (exists $configfwdfw{$last}){
				#save rule last
				foreach my $y (0 .. $#{$configfwdfw{$last}}) {
						$tmp{0}[$y] = $configfwdfw{$last}[$y];
				}
				#copy active rule to last
				foreach my $i (0 .. $#{$configfwdfw{$last}}) {
					$configfwdfw{$last}[$i] = $configfwdfw{$key}[$i];
				}
				#copy saved rule to actual position
				foreach my $x (0 .. $#{$tmp{0}}) {
						$configfwdfw{$key}[$x] = $tmp{0}[$x];
				}
			}
		}
	}
	&General::writehasharray("$configfwdfw", \%configfwdfw);
}
sub pos_down
{
	my %tmp=();
	&General::readhasharray("$configfwdfw", \%configfwdfw);
	foreach my $key (sort keys %configfwdfw){
		if ($key eq $fwdfwsettings{'key'}) {
			my $next = $key + 1;
			if (exists $configfwdfw{$next}){
				#save rule next
				foreach my $y (0 .. $#{$configfwdfw{$next}}) {
						$tmp{0}[$y] = $configfwdfw{$next}[$y];
				}
				#copy active rule to next
				foreach my $i (0 .. $#{$configfwdfw{$next}}) {
					$configfwdfw{$next}[$i] = $configfwdfw{$key}[$i];
				}
				#copy saved rule to actual position
				foreach my $x (0 .. $#{$tmp{0}}) {
						$configfwdfw{$key}[$x] = $tmp{0}[$x];
				}
			}
		}
	}
	&General::writehasharray("$configfwdfw", \%configfwdfw);
}
sub checkcounter
{
	my ($base1,$val1,$base2,$val2) = @_;
	#$errormessage.=" BASE1:$base1 VAL1:$val1 BASE2:$base2, VAL2:$val2<br>";
	
	if($base1 eq 'cust_net_src' || $base1 eq 'cust_net_tgt'){
		&dec_counter($confignet,\%customnetwork,$val1);
	}elsif($base1 eq 'cust_host_src' || $base1 eq 'cust_host_tgt'){
		&dec_counter($confighost,\%customhost,$val1);
	}elsif($base1 eq 'cust_grp_src' || $base1 eq 'cust_grp_tgt'){
		&dec_counter($configgrp,\%customgrp,$val1);
	}elsif($base1 eq 'cust_srv'){
		&dec_counter($configsrv,\%customservice,$val1);
	}elsif($base1 eq 'cust_srvgrp'){
		&dec_counter($configsrvgrp,\%customservicegrp,$val1);	
	}
	
	if($base2 eq 'cust_net_src' || $base2 eq 'cust_net_tgt'){
		&inc_counter($confignet,\%customnetwork,$val2);
	}elsif($base2 eq 'cust_host_src' || $base2 eq 'cust_host_tgt'){
		&inc_counter($confighost,\%customhost,$val2);
	}elsif($base2 eq 'cust_grp_src' || $base2 eq 'cust_grp_tgt'){
		&inc_counter($configgrp,\%customgrp,$val2);
	}elsif($base2 eq 'cust_srv'){
		&inc_counter($configsrv,\%customservice,$val2);
	}elsif($base2 eq 'cust_srvgrp'){
		&inc_counter($configsrvgrp,\%customservicegrp,$val2);	
	}
}
sub inc_counter
{
	my $config=shift;
	my %hash=%{(shift)};
	my $val=shift;
	my $pos;
	#$errormessage.="NEU: config: $config , erhöht wird $val<br>";
	&General::readhasharray($config, \%hash);
	foreach my $key (sort { uc($hash{$a}[0]) cmp uc($hash{$b}[0]) }  keys %hash){
		if($hash{$key}[0] eq $val){
			$pos=$#{$hash{$key}};
			$hash{$key}[$pos] = $hash{$key}[$pos]+1;
			
		}
	}
	&General::writehasharray($config, \%hash);
}
sub dec_counter
{
	my $config=shift;
	my %hash=%{(shift)};
	my $val=shift;
	my $pos;
	#$errormessage.="ALT:config: $config , verringert wird $val <br>";
	&General::readhasharray($config, \%hash);
	foreach my $key (sort { uc($hash{$a}[0]) cmp uc($hash{$b}[0]) }  keys %hash){
		if($hash{$key}[0] eq $val){
			$pos=$#{$hash{$key}};
			$hash{$key}[$pos] = $hash{$key}[$pos]-1;
			
		}
	}
	&General::writehasharray($config, \%hash);
}
sub base
{
	
	if ($fwdfwsettings{'POLICY'} eq 'MODE0'){ $selected{'POLICY'}{'MODE0'} = 'selected'; } else { $selected{'POLICY'}{'MODE0'} = ''; }
	if ($fwdfwsettings{'POLICY'} eq 'MODE1'){ $selected{'POLICY'}{'MODE1'} = 'selected'; } else { $selected{'POLICY'}{'MODE1'} = ''; }
	if ($fwdfwsettings{'POLICY'} eq 'MODE2'){ $selected{'POLICY'}{'MODE2'} = 'selected'; } else { $selected{'POLICY'}{'MODE2'} = ''; }
	if ($fwdfwsettings{'POLICY'} ne 'MODE0'  && $fwdfwsettings{'POLICY'} ne '') {
		&addrule;
	}
	&Header::openbox('100%', 'center', 'Policy');
	
	
	#COLORS
	
	#print"<table width='100%' border='1'><tr>";
	#foreach my $i ( 1 .. 40){
		#my $r = 'color'.$i;
		#print"<td bgcolor='$color{$r}' width='2%' align='center'>$i</td>";
	#}
	#print"</td></tr></table>";
	
	
print <<END;
	<form method='post' action='$ENV{'SCRIPT_NAME'}'>
	<table width='100%'>
		<tr><td width='10%' align='left'><b>$Lang::tr{'mode'} 0:</b><td width='90%' align='left' colspan='2'>$Lang::tr{'outgoing firewall mode0'}</td></tr>
		<tr><td width='10%' align='left'><b>$Lang::tr{'mode'} 1:</b><td width='90%' align='left' colspan='2'>$Lang::tr{'outgoing firewall mode1'}</td></tr>
		<tr><td width='10%' align='left'><b>$Lang::tr{'mode'} 2:</b><td width='90%' align='left' colspan='2'>$Lang::tr{'outgoing firewall mode2'}</td></tr>
		<tr><td colspan='3'><hr /></td></tr>
		<tr><td width='10%' align='left'>	<select name='POLICY' style="width: 85px"><option value='MODE0' $selected{'POLICY'}{'MODE0'}>$Lang::tr{'mode'} 0</option><option value='MODE1' $selected{'POLICY'}{'MODE1'}>$Lang::tr{'mode'} 1</option><option value='MODE2' $selected{'POLICY'}{'MODE2'}>$Lang::tr{'mode'} 2</option></select>
		    <td width='45%' align='left'><input type='submit' name='ACTION' value=$Lang::tr{'save'} />
		    <td width='45%' align='left'>
END

	if ($fwdfwsettings{'POLICY'} ne 'MODE0'&& $fwdfwsettings{'POLICY'} ne '' ) {
		print <<END;
		    $Lang::tr{'outgoing firewall reset'}: <input type='submit' name='ACTION' value='$Lang::tr{'reset'}' />
END
	
	}
print <<END;
	</table>
	</form>
END

	&Header::closebox();
}
sub addrule
{
	&error;
	&Header::openbox('100%', 'left', $Lang::tr{'fwdfw addrule'});
	
print <<END;
	<form method="post">
	<table border='0'>
	<tr><td><input type='submit' name='ACTION' value='$Lang::tr{'fwdfw newrule'}'></td></tr></table></form><hr>	
END

	&Header::closebox();
	&viewtablerule;
	
}
sub checksource
{
	my ($ip,$subnet);
	
	#check ip-address if manual
	if ($fwdfwsettings{'src_addr'} eq $fwdfwsettings{$fwdfwsettings{'grp1'}} && $fwdfwsettings{'src_addr'} ne ''){
		#check if ip with subnet
		if ($fwdfwsettings{'src_addr'} =~ /^(.*?)\/(.*?)$/) {
			($ip,$subnet)=split (/\//,$fwdfwsettings{'src_addr'});
			$subnet = &General::iporsubtocidr($subnet);
		}
		#check if only ip
		if($fwdfwsettings{'src_addr'}=~/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/){
			$ip=$fwdfwsettings{'src_addr'};
			$subnet = '32';
		}
		#check and form valid IP
		$ip=&General::ip2dec($ip);
		$ip=&General::dec2ip($ip);
		#check if net or broadcast
		my @tmp= split (/\./,$ip);
		if (($tmp[3] eq "0") || ($tmp[3] eq "255"))
		{
			$errormessage=$Lang::tr{'fwhost err hostip'};
		}
		$fwdfwsettings{'src_addr'}="$ip/$subnet";
				
		if(!&General::validipandmask($fwdfwsettings{'src_addr'})){
			$errormessage.=$Lang::tr{'fwdfw err src_addr'}."<br>";
		}
	}elsif($fwdfwsettings{'src_addr'} eq $fwdfwsettings{$fwdfwsettings{'grp1'}} && $fwdfwsettings{'src_addr'} eq ''){
		$errormessage.=$Lang::tr{'fwdfw err nosrcip'};
		return $errormessage;
	}
		
	#check empty fields
	if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq ''){ $errormessage.=$Lang::tr{'fwdfw err nosrc'}."<br>";}
	#check icmp source
		if ($fwdfwsettings{'USE_SRC_PORT'} eq 'ON' && $fwdfwsettings{'PROT'} eq 'ICMP'){
			$fwdfwsettings{'SRC_PORT'}='';
			&General::readhasharray("${General::swroot}/fwhosts/icmp-types", \%icmptypes);
			foreach my $key (keys %icmptypes){
				if($fwdfwsettings{'ICMP_TYPES'} eq "$icmptypes{$key}[0] ($icmptypes{$key}[1])"){
					$fwdfwsettings{'ICMP_TYPES'}="$icmptypes{$key}[0] - $icmptypes{$key}[1]";
				}
			}
		}elsif($fwdfwsettings{'USE_SRC_PORT'} eq 'ON' && $fwdfwsettings{'PROT'} ne 'ICMP'){
			$fwdfwsettings{'ICMP_TYPES'}='';
		}else{
			$fwdfwsettings{'ICMP_TYPES'}='';
			$fwdfwsettings{'SRC_PORT'}='';
			$fwdfwsettings{'PROT'}='';
		}
		
	if($fwdfwsettings{'USE_SRC_PORT'} eq 'ON' && $fwdfwsettings{'PROT'} ne 'ICMP' && $fwdfwsettings{'SRC_PORT'} ne ''){
		#change dashes with :
		$fwdfwsettings{'SRC_PORT'}=~ tr/-/:/;
			
		if ($fwdfwsettings{'SRC_PORT'} eq "*") {
			$fwdfwsettings{'SRC_PORT'} = "1:65535";
		}
		if ($fwdfwsettings{'SRC_PORT'} =~ /^(\D)\:(\d+)$/) {
			$fwdfwsettings{'SRC_PORT'} = "1:$2";
		}
		if ($fwdfwsettings{'SRC_PORT'} =~ /^(\d+)\:(\D)$/) {
			$fwdfwsettings{'SRC_PORT'} = "$1:65535";
		}
		
		$errormessage.=&General::validportrange($fwdfwsettings{'SRC_PORT'},'src');
	}
	return $errormessage;
}
sub checktarget
{
	my ($ip,$subnet);
	if ($fwdfwsettings{'tgt_addr'} eq $fwdfwsettings{$fwdfwsettings{'grp2'}} && $fwdfwsettings{'tgt_addr'} ne ''){
		#check if ip with subnet
		if ($fwdfwsettings{'tgt_addr'} =~ /^(.*?)\/(.*?)$/) {
			($ip,$subnet)=split (/\//,$fwdfwsettings{'tgt_addr'});
			$subnet = &General::iporsubtocidr($subnet);
		}
		#check if only ip
		if($fwdfwsettings{'tgt_addr'}=~/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/){
			$ip=$fwdfwsettings{'tgt_addr'};
			$subnet='32';
		}
		
		#check and form valid IP
		$ip=&General::ip2dec($ip);
		$ip=&General::dec2ip($ip);
		
		#check if net or broadcast
		my @tmp= split (/\./,$ip);
		if (($tmp[3] eq "0") || ($tmp[3] eq "255"))
		{
			$errormessage=$Lang::tr{'fwhost err hostip'};
		}
		$fwdfwsettings{'tgt_addr'}=$ip."/".$subnet;
				
		if(!&General::validipandmask($fwdfwsettings{'tgt_addr'})){
			$errormessage.=$Lang::tr{'fwdfw err tgt_addr'}."<br>";
		}
	}elsif($fwdfwsettings{'tgt_addr'} eq $fwdfwsettings{$fwdfwsettings{'grp2'}} && $fwdfwsettings{'tgt_addr'} eq ''){
		$errormessage.=$Lang::tr{'fwdfw err notgtip'};
		return $errormessage;
	}
		
	#check empty fields
	if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq ''){ $errormessage.=$Lang::tr{'fwdfw err notgt'}."<br>";}
	#check icmp target
	if ($fwdfwsettings{'USESRV'} eq 'ON' && $fwdfwsettings{'TGT_PROT'} eq 'ICMP'){
		$fwdfwsettings{'TGT_PORT'}='';
		&General::readhasharray("${General::swroot}/fwhosts/icmp-types", \%icmptypes);
		foreach my $key (keys %icmptypes){
			if($fwdfwsettings{'ICMP_TGT'} eq "$icmptypes{$key}[0] ($icmptypes{$key}[1])"){
				$fwdfwsettings{'ICMP_TGT'}="$icmptypes{$key}[0] - $icmptypes{$key}[1]";
			}
		}
	}elsif($fwdfwsettings{'USESRV'} eq 'ON' && $fwdfwsettings{'PROT'} ne 'ICMP'){
		$fwdfwsettings{'ICMP_TGT'}='';
	}else{
		$fwdfwsettings{'ICMP_TGT'}='';
		$fwdfwsettings{'TGT_PORT'}='';
		$fwdfwsettings{'TGT_PROT'}='';
	}
	#check target port		
	if($fwdfwsettings{'USESRV'} eq 'ON' && $fwdfwsettings{'grp3'} eq 'TGT_PORT' ){		
		#check tgt port field if filled
		if ($fwdfwsettings{'TGT_PORT'} ne ''){
			#change dashes with :
			$fwdfwsettings{'TGT_PORT'}=~ tr/-/:/;
				
			if ($fwdfwsettings{'TGT_PORT'} eq "*") {
				$fwdfwsettings{'TGT_PORT'} = "1:65535";
			}
			if ($fwdfwsettings{'TGT_PORT'} =~ /^(\D)\:(\d+)$/) {
				$fwdfwsettings{'TGT_PORT'} = "1:$2";
			}
			if ($fwdfwsettings{'TGT_PORT'} =~ /^(\d+)\:(\D)$/) {
				$fwdfwsettings{'TGT_PORT'} = "$1:65535";
			}
			$errormessage .= &General::validportrange($fwdfwsettings{'TGT_PORT'}, 'destination');
		
		}
		#check targetport
		if ($fwdfwsettings{'USESRV'} ne 'ON'){
			$fwdfwsettings{'grp3'}='';
			$fwdfwsettings{$fwdfwsettings{'grp3'}}='';
			$fwdfwsettings{'TGT_PROT'}='';
		}
		#check target service
		if($fwdfwsettings{'USESRV'} eq 'ON' && $fwdfwsettings{'grp3'} ne 'TGT_PORT' && $fwdfwsettings{$fwdfwsettings{'grp3'}} eq ''){
			$errormessage.=$Lang::tr{'fwdfw err tgt_grp'};
		}
	}
	return $errormessage;
}
sub checkrule
{
	#check valid remark
	if ($fwdfwsettings{'ruleremark'} ne '' && !&validremark($fwdfwsettings{'ruleremark'})){
		$errormessage.=$Lang::tr{'fwdfw err remark'}."<br>";
	}
	
	#check if source and target identical
	if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $fwdfwsettings{$fwdfwsettings{'grp2'}}){
		$errormessage.=$Lang::tr{'fwdfw err same'};
		return $errormessage;
	}
	#get source and targetip address if possible
	my ($sip,$scidr,$tip,$tcidr);
	($sip,$scidr)=&get_ip("src","grp1");
	($tip,$tcidr)=&get_ip("tgt","grp2");
	#check same iprange in source and target
	if ($sip ne '' && $scidr ne '' && $tip ne '' && $tcidr ne ''){
		my $networkip1=&General::getnetworkip($sip,$scidr);
		my $networkip2=&General::getnetworkip($tip,$tcidr);
		if ($scidr gt $tcidr){
			if ( &General::IpInSubnet($networkip1,$tip,&General::iporsubtodec($tcidr)) ){
				$errormessage.=$Lang::tr{'fwdfw err samesub'};
			}
		}else{
			if ( &General::IpInSubnet($networkip2,$sip,&General::iporsubtodec($scidr)) ){
				$errormessage.=$Lang::tr{'fwdfw err samesub'};
			}
		}
	}
	#check source and destination protocol if manual
	if( $fwdfwsettings{'USE_SRC_PORT'} eq 'ON' && $fwdfwsettings{'USESRV'} eq 'ON'){
		if($fwdfwsettings{'PROT'} ne $fwdfwsettings{'TGT_PROT'} && $fwdfwsettings{'grp3'} eq 'TGT_PORT'){
			$errormessage.=$Lang::tr{'fwdfw err prot'};
		}
		#check source and destination protocol if source manual and dest servicegrp
		if ($fwdfwsettings{'grp3'} eq 'cust_srv'){
			&General::readhasharray("$configsrv", \%customservice);
			foreach my $key (sort keys %customservice){
				if($customservice{$key}[0] eq $fwdfwsettings{$fwdfwsettings{'grp3'}}){
					if ($customservice{$key}[2] ne $fwdfwsettings{'PROT'}){
						$errormessage.=$Lang::tr{'fwdfw err prot'};
					}
				}
			}
		}
	}
	
	
	
	
}
sub get_ip
{
	my $val=shift;
	my $grp =shift;
	my $a;
	my $b;
	&General::readhash("/var/ipfire/ethernet/settings", \%netsettings);
	if ($fwdfwsettings{$grp} ne $Lang::tr{'fwhost any'}){
		if ($fwdfwsettings{$grp} eq $val.'_addr'){
			($a,$b)   = split (/\//, $fwdfwsettings{$fwdfwsettings{$grp}});
		}elsif($fwdfwsettings{$grp} eq 'std_net_'.$val){
			if ($fwdfwsettings{$fwdfwsettings{$grp}} =~ /Gr/i){
				$a=$netsettings{'GREEN_NETADDRESS'};
				$b=&General::iporsubtocidr($netsettings{'GREEN_NETMASK'});
			}elsif($fwdfwsettings{$fwdfwsettings{$grp}} =~ /Ora/i){
				$a=$netsettings{'ORANGE_NETADDRESS'};
				$b=&General::iporsubtocidr($netsettings{'ORANGE_NETMASK'});
			}elsif($fwdfwsettings{$fwdfwsettings{$grp}} =~ /Bl/i){
				$a=$netsettings{'BLUE_NETADDRESS'};
				$b=&General::iporsubtocidr($netsettings{'BLUE_NETMASK'});
			}elsif($fwdfwsettings{$fwdfwsettings{$grp}} =~ /OpenVPN/i){
				&General::readhash("$configovpn",\%ovpnsettings);
				($a,$b)   = split (/\//, $ovpnsettings{'DOVPN_SUBNET'});
				$b=&General::iporsubtocidr($b);
			}
		}elsif($fwdfwsettings{$grp} eq 'cust_net_'.$val){
			&General::readhasharray("$confignet", \%customnetwork);
			foreach my $key (keys %customnetwork){
				if($customnetwork{$key}[0] eq $fwdfwsettings{$fwdfwsettings{$grp}}){
					$a=$customnetwork{$key}[1];
					$b=&General::iporsubtocidr($customnetwork{$key}[2]);
				}
			}
		}elsif($fwdfwsettings{$grp} eq 'cust_host_'.$val){
			&General::readhasharray("$confighost", \%customhost);
			foreach my $key (keys %customhost){
				if($customhost{$key}[0] eq $fwdfwsettings{$fwdfwsettings{$grp}}){
					($a,$b)=split (/\//,$customhost{$key}[2]);
					$b=&General::iporsubtocidr($b);
				}
			}
		}
	}
	
	return $a,$b;
}
sub newrule
{
	&error;
	&setup_default_networks(\%defaultNetworks);
	#read all configfiles
	&General::readhasharray("$configccdnet", \%ccdnet);
	&General::readhasharray("$confignet", \%customnetwork);
	&General::readhasharray("$configccdhost", \%ccdhost);
	&General::readhasharray("$confighost", \%customhost);
	&General::readhasharray("$configccdhost", \%ccdhost);
	&General::readhasharray("$configgrp", \%customgrp);
	&General::readhasharray("$configipsec", \%ipsecconf);
		
	my %checked=();
	my $helper;
	
	$checked{'grp1'}{$fwdfwsettings{'grp1'}} 				= 'CHECKED';
	$checked{'grp2'}{$fwdfwsettings{'grp2'}} 				= 'CHECKED';
	$checked{'grp3'}{$fwdfwsettings{'grp3'}} 				= 'CHECKED';
	$checked{'USE_SRC_PORT'}{$fwdfwsettings{'USE_SRC_PORT'}} = 'CHECKED';
	$checked{'USESRV'}{$fwdfwsettings{'USESRV'}} 			= 'CHECKED';
	$checked{'ACTIVE'}{$fwdfwsettings{'ACTIVE'}} 			= 'CHECKED';
	$checked{'LOG'}{$fwdfwsettings{'LOG'}} 					= 'CHECKED';
	$checked{'TIME'}{$fwdfwsettings{'TIME'}} 				= 'CHECKED';
	$checked{'TIME_MON'}{$fwdfwsettings{'TIME_MON'}} 		= 'CHECKED';
	$checked{'TIME_TUE'}{$fwdfwsettings{'TIME_TUE'}} 		= 'CHECKED';
	$checked{'TIME_WED'}{$fwdfwsettings{'TIME_WED'}} 		= 'CHECKED';
	$checked{'TIME_THU'}{$fwdfwsettings{'TIME_THU'}} 		= 'CHECKED';
	$checked{'TIME_FRI'}{$fwdfwsettings{'TIME_FRI'}} 		= 'CHECKED';
	$checked{'TIME_SAT'}{$fwdfwsettings{'TIME_SAT'}} 		= 'CHECKED';
	$checked{'TIME_SUN'}{$fwdfwsettings{'TIME_SUN'}} 		= 'CHECKED';
	$selected{'TIME_FROM'}{$fwdfwsettings{'TIME_FROM'}}		= 'selected';
	$selected{'TIME_TO'}{$fwdfwsettings{'TIME_TO'}}			= 'selected';
	
	#check if update and get values
	if($fwdfwsettings{'updatefwrule'} eq 'on' || $fwdfwsettings{'copyfwrule'} eq 'on' && !$errormessage){
		&General::readhasharray("$configfwdfw", \%configfwdfw);
		foreach my $key (sort keys %configfwdfw){
			if ($key eq $fwdfwsettings{'key'}){
				$fwdfwsettings{'RULE_ACTION'}			= $configfwdfw{$key}[0];
				$fwdfwsettings{'ACTIVE'}				= $configfwdfw{$key}[2];
				$fwdfwsettings{'grp1'}					= $configfwdfw{$key}[3];   
				$fwdfwsettings{$fwdfwsettings{'grp1'}}	= $configfwdfw{$key}[4];   
				$fwdfwsettings{'grp2'}					= $configfwdfw{$key}[5];   
				$fwdfwsettings{$fwdfwsettings{'grp2'}}	= $configfwdfw{$key}[6];   
				$fwdfwsettings{'USE_SRC_PORT'}			= $configfwdfw{$key}[7];
				$fwdfwsettings{'PROT'}					= $configfwdfw{$key}[8];
			    $fwdfwsettings{'ICMP_TYPES'}			= $configfwdfw{$key}[9];
			    $fwdfwsettings{'SRC_PORT'}				= $configfwdfw{$key}[10];
			    $fwdfwsettings{'USESRV'}				= $configfwdfw{$key}[11];
			    $fwdfwsettings{'TGT_PROT'}				= $configfwdfw{$key}[12];
			    $fwdfwsettings{'ICMP_TGT'}				= $configfwdfw{$key}[13];
			    $fwdfwsettings{'grp3'}					= $configfwdfw{$key}[14];
			    $fwdfwsettings{$fwdfwsettings{'grp3'}}	= $configfwdfw{$key}[15];
			    $fwdfwsettings{'ruleremark'}			= $configfwdfw{$key}[16];
			    $fwdfwsettings{'LOG'}					= $configfwdfw{$key}[17];
			    $fwdfwsettings{'TIME'}					= $configfwdfw{$key}[18];
				$fwdfwsettings{'TIME_MON'}				= $configfwdfw{$key}[19];
				$fwdfwsettings{'TIME_TUE'}				= $configfwdfw{$key}[20];
				$fwdfwsettings{'TIME_WED'}				= $configfwdfw{$key}[21];
				$fwdfwsettings{'TIME_THU'}				= $configfwdfw{$key}[22];
				$fwdfwsettings{'TIME_FRI'}				= $configfwdfw{$key}[23];
				$fwdfwsettings{'TIME_SAT'}				= $configfwdfw{$key}[24];
				$fwdfwsettings{'TIME_SUN'}				= $configfwdfw{$key}[25];
				$fwdfwsettings{'TIME_FROM'}				= $configfwdfw{$key}[26];
				$fwdfwsettings{'TIME_TO'}				= $configfwdfw{$key}[27];
				 
				$checked{'grp1'}{$fwdfwsettings{'grp1'}} 				= 'CHECKED';
				$checked{'grp2'}{$fwdfwsettings{'grp2'}} 				= 'CHECKED';
				$checked{'grp3'}{$fwdfwsettings{'grp3'}} 				= 'CHECKED';
				$checked{'USE_SRC_PORT'}{$fwdfwsettings{'USE_SRC_PORT'}} = 'CHECKED';
				$checked{'USESRV'}{$fwdfwsettings{'USESRV'}} 			= 'CHECKED';
				$checked{'ACTIVE'}{$fwdfwsettings{'ACTIVE'}} 			= 'CHECKED';
				$checked{'LOG'}{$fwdfwsettings{'LOG'}} 					= 'CHECKED';
				$checked{'TIME'}{$fwdfwsettings{'TIME'}} 				= 'CHECKED';
				$checked{'TIME_MON'}{$fwdfwsettings{'TIME_MON'}} 		= 'CHECKED';
				$checked{'TIME_TUE'}{$fwdfwsettings{'TIME_TUE'}} 		= 'CHECKED';
				$checked{'TIME_WED'}{$fwdfwsettings{'TIME_WED'}} 		= 'CHECKED';
				$checked{'TIME_THU'}{$fwdfwsettings{'TIME_THU'}} 		= 'CHECKED';
				$checked{'TIME_FRI'}{$fwdfwsettings{'TIME_FRI'}} 		= 'CHECKED';
				$checked{'TIME_SAT'}{$fwdfwsettings{'TIME_SAT'}} 		= 'CHECKED';
				$checked{'TIME_SUN'}{$fwdfwsettings{'TIME_SUN'}} 		= 'CHECKED';
				$selected{'TIME_FROM'}{$fwdfwsettings{'TIME_FROM'}}		= 'selected';
				$selected{'TIME_TO'}{$fwdfwsettings{'TIME_TO'}}			= 'selected';
			}
		}
		$fwdfwsettings{'oldgrp1a'}=$fwdfwsettings{'grp1'};
		$fwdfwsettings{'oldgrp1b'}=$fwdfwsettings{$fwdfwsettings{'grp1'}};
		$fwdfwsettings{'oldgrp2a'}=$fwdfwsettings{'grp2'};
		$fwdfwsettings{'oldgrp2b'}=$fwdfwsettings{$fwdfwsettings{'grp2'}};
		$fwdfwsettings{'oldgrp3a'}=$fwdfwsettings{'grp3'};
		$fwdfwsettings{'oldgrp3b'}=$fwdfwsettings{$fwdfwsettings{'grp3'}};
	}else{
		$fwdfwsettings{'ACTIVE'}='ON';
		$checked{'ACTIVE'}{$fwdfwsettings{'ACTIVE'}} = 'CHECKED';
	}
	
	&Header::openbox('100%', 'left', $Lang::tr{'fwdfw addrule'});
	
print <<END;
	<form method="post">
	<table border='0'>
	<tr><td nowrap>$Lang::tr{'fwdfw rule action'}</td><td><select name='RULE_ACTION'>
END
	foreach ("ACCEPT","DROP","REJECT")
	{
		if ($_ eq $fwdfwsettings{'RULE_ACTION'})
		{
			print"<option selected>$_</option>";
		}else{
			print"<option>$_</option>";
		}
	}
	print"</select></td></tr></table><hr>";	


	&Header::closebox();
	&Header::openbox('100%', 'left', $Lang::tr{'fwdfw source'});
	
	
	#------SOURCE-------------------------------------------------------
	print<<END;
		<table width='100%' border='0'>
		<tr><td width='1%'><input type='radio' name='grp1' value='src_addr'  checked></td><td colspan='5'>$Lang::tr{'fwdfw sourceip'}<input type='TEXT' name='src_addr' value='$fwdfwsettings{'src_addr'}' ></td></tr>
		<tr><td colspan='7'><hr style='border:dotted #BFBFBF; border-width:1px 0 0 0 ; ' /></td></tr>
		<tr><td width='1%'><input type='radio' name='grp1' value='std_net_src' $checked{'grp1'}{'std_net_src'}></td><td nowrap='nowrap' width='12%'>$Lang::tr{'fwhost stdnet'}</td><td width='13%'><select name='std_net_src' style='min-width:185px;'>
		
END
		foreach my $network (sort keys %defaultNetworks)
		{
			next if($defaultNetworks{$network}{'LOCATION'} eq "IPCOP");
			print "<option value='$network'";
			print " selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $network);
			print ">$network</option>";
		}
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp1' value='ovpn_net_src'  $checked{'grp1'}{'ovpn_net_src'}></td><td nowrap='nowrap' width='16%'>$Lang::tr{'fwhost ccdnet'}</td><td nowrap='nowrap' width='1%'><select name='ovpn_net_src' style='min-width:185px;'>
END
		&fillselect(\%ccdnet,$fwdfwsettings{$fwdfwsettings{'grp1'}});
		print<<END;
		</select></td></tr>
		<tr><td><input type='radio' name='grp1' value='cust_net_src' $checked{'grp1'}{'cust_net_src'}></td><td>$Lang::tr{'fwhost cust net'}</td><td><select name='cust_net_src' style='min-width:185px;'>
END
		&fillselect(\%customnetwork,$fwdfwsettings{$fwdfwsettings{'grp1'}});
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp1' value='ovpn_host_src' $checked{'grp1'}{'ovpn_host_src'}></td><td nowrap='nowrap' width='16%'>$Lang::tr{'fwhost ccdhost'}</td><td nowrap='nowrap' width='1%'><select name='ovpn_host_src' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ccdhost{$a}[0]) cmp uc($ccdhost{$b}[0]) } keys %ccdhost)
		{
			if ($ccdhost{$key}[33] ne ''){
				
				print "<option value='$ccdhost{$key}[1]'";
				print "selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $ccdhost{$key}[1]);
				print ">$ccdhost{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		<tr><td valign='top'><input type='radio' name='grp1' value='cust_host_src' $checked{'grp1'}{'cust_host_src'}></td><td>$Lang::tr{'fwhost cust addr'}</td><td><select name='cust_host_src' style='min-width:185px;'>
END
		&fillselect(\%customhost,$fwdfwsettings{$fwdfwsettings{'grp1'}});
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp1' value='ovpn_n2n_src' $checked{'grp1'}{'ovpn_n2n_src'}></td><td >$Lang::tr{'fwhost ovpn_n2n'}</td><td colspan='3'><select name='ovpn_n2n_src' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ccdhost{$a}[0]) cmp uc($ccdhost{$b}[0]) } keys %ccdhost) {
			if($ccdhost{$key}[3] eq 'net'){
				print"<option ";
				print " selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $ccdhost{$key}[1]);
				print ">$ccdhost{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		
		<tr><td valign='top'><input type='radio' name='grp1' value='cust_grp_src' $checked{'grp1'}{'cust_grp_src'}></td><td >$Lang::tr{'fwhost cust grp'}</td><td><select name='cust_grp_src' style='min-width:185px;'>
END
		foreach my $key (sort { uc($customgrp{$a}[0]) cmp uc($customgrp{$b}[0]) } keys %customgrp) {
			if($helper ne $customgrp{$key}[0]){
				print"<option ";
				print "selected='selected' " if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $customgrp{$key}[0]);
				print ">$customgrp{$key}[0]</option>";
				
			
			}
			$helper=$customgrp{$key}[0];
		}
		print<<END;
		</select></td>
		<td valign='top'><input type='radio' name='grp1' value='ipsec_host_src' $checked{'grp1'}{'ipsec_host_src'}></td><td >$Lang::tr{'fwhost ipsec host'}</td><td><select name='ipsec_host_src' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ipsecconf{$a}[1]) cmp uc($ipsecconf{$b}[1]) } keys %ipsecconf) {
			if ($ipsecconf{$key}[3] eq 'host'){
				print "<option ";
				print "selected='selected'" if($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $ipsecconf{$key}[1]);
				print ">$ipsecconf{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		<tr><td colspan='3'></td><td valign='top'><input type='radio' name='grp1' value='ipsec_net_src' $checked{'grp1'}{'ipsec_net_src'}></td><td >$Lang::tr{'fwhost ipsec net'}</td><td><select name='ipsec_net_src' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ipsecconf{$a}[1]) cmp uc($ipsecconf{$b}[1]) } keys %ipsecconf) {
			if ($ipsecconf{$key}[3] eq 'net'){
				print "<option ";
				print "selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp1'}} eq $ipsecconf{$key}[1]);
				print ">$ipsecconf{$key}[1]</option>";
			}
		}
		#sourceport
		print<<END;
		</select></td></tr>
		<tr><td colspan='8'><hr style='border:dotted #BFBFBF; border-width:1px 0 0 0 ; ' /></td></tr></table>
		
		
		<table width='100%' border='0'>
		<tr><td width='1%'><input type='checkbox' name='USE_SRC_PORT' value='ON' $checked{'USE_SRC_PORT'}{'ON'}></td><td width='51%' colspan='3'>$Lang::tr{'fwdfw use srcport'}</td>
		<td width='15%' nowrap='nowrap'>$Lang::tr{'fwdfw man port'}</td><td><select name='PROT'>
END
		foreach ("TCP","UDP","GRE","ICMP")
		{
			if ($_ eq $fwdfwsettings{'PROT'})
			{
				print"<option selected>$_</option>";
			}else{
				print"<option>$_</option>";
			}
		}
		print<<END;
		</select></td><td align='right'><input type='text' name='SRC_PORT' value='$fwdfwsettings{'SRC_PORT'}' maxlength='11' size='9' ></td></tr>
		<tr><td></td><td></td><td></td><td></td><td nowrap='nowrap'>$Lang::tr{'fwhost icmptype'}</td><td colspan='2'><select name='ICMP_TYPES'>
END
		&General::readhasharray("${General::swroot}/fwhosts/icmp-types", \%icmptypes);
		print"<option>All ICMP-Types</option>";
		foreach my $key (sort { uc($icmptypes{$a}[0]) cmp uc($icmptypes{$b}[0]) } keys %icmptypes){
			if($fwdfwsettings{'ICMP_TYPES'} eq "$icmptypes{$key}[0] - $icmptypes{$key}[1]"){
				print"<option selected>$icmptypes{$key}[0] ($icmptypes{$key}[1])</option>";
			}else{
				print"<option>$icmptypes{$key}[0] ($icmptypes{$key}[1])</option>";
			}
		}
		print<<END;
		</select></td></tr></table><hr>
END
		&Header::closebox();

		#---TARGET------------------------------------------------------
		&Header::openbox('100%', 'left', $Lang::tr{'fwdfw target'});
		print<<END;
		<table width='100%' border='0'>	
		<tr><td width='1%'><input type='radio' name='grp2' value='tgt_addr'  checked></td><td colspan='5'>$Lang::tr{'fwdfw targetip'}<input type='TEXT' name='tgt_addr' value='$fwdfwsettings{'tgt_addr'}' ></td></tr>
		<tr><td colspan='7'><hr style='border:dotted #BFBFBF; border-width:1px 0 0 0 ; ' /></td></tr>
		<tr><td width='1%'><input type='radio' name='grp2' value='std_net_tgt' $checked{'grp2'}{'std_net_tgt'}></td><td nowrap='nowrap' width='12%'>$Lang::tr{'fwhost stdnet'}</td><td width='13%'><select name='std_net_tgt' style='min-width:185px;'>
		
END
		foreach my $network (sort keys %defaultNetworks)
		{
			next if($defaultNetworks{$network}{'LOCATION'} eq "IPCOP");
			print "<option value='$network'";
			print " selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq $network);
			print ">$network</option>";
		}
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp2' value='ovpn_net_tgt'  $checked{'grp2'}{'ovpn_net_tgt'}></td><td nowrap='nowrap' width='16%'>$Lang::tr{'fwhost ccdnet'}</td><td nowrap='nowrap' width='1%'><select name='ovpn_net_tgt' style='min-width:185px;'>
END
		&fillselect(\%ccdnet,$fwdfwsettings{$fwdfwsettings{'grp2'}});
		
		print<<END;
		</select></td></tr>
		<tr><td><input type='radio' name='grp2' value='cust_net_tgt' $checked{'grp2'}{'cust_net_tgt'}></td><td>$Lang::tr{'fwhost cust net'}</td><td><select name='cust_net_tgt' style='min-width:185px;'>
END
		&fillselect(\%customnetwork,$fwdfwsettings{$fwdfwsettings{'grp2'}});
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp2' value='ovpn_host_tgt' $checked{'grp2'}{'ovpn_host_tgt'}></td><td nowrap='nowrap' width='16%'>$Lang::tr{'fwhost ccdhost'}</td><td nowrap='nowrap' width='1%'><select name='ovpn_host_tgt' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ccdhost{$a}[0]) cmp uc($ccdhost{$b}[0]) } keys %ccdhost)
		{
			if ($ccdhost{$key}[33] ne ''){
				print "<option value='$ccdhost{$key}[1]' ";
				print "selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq $ccdhost{$key}[33]);
				print ">$ccdhost{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		<tr><td valign='top'><input type='radio' name='grp2' value='cust_host_tgt' $checked{'grp2'}{'cust_host_tgt'}></td><td>$Lang::tr{'fwhost cust addr'}</td><td><select name='cust_host_tgt' style='min-width:185px;'>
END
		&fillselect(\%customhost,$fwdfwsettings{$fwdfwsettings{'grp2'}});
		print<<END;
		</select></td><td width='1%'><input type='radio' name='grp2' value='ovpn_n2n_tgt' $checked{'grp2'}{'ovpn_n2n_tgt'}></td><td >$Lang::tr{'fwhost ovpn_n2n'}</td><td colspan='3'><select name='ovpn_n2n_tgt' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ccdhost{$a}[0]) cmp uc($ccdhost{$b}[0]) } keys %ccdhost) {
			if($ccdhost{$key}[3] eq 'net'){
				print "<option ";
				print "selected='selected'" if($fwdfwsettings{$fwdfwsettings{'grp2'}} eq $ccdhost{$key}[1]);
				print ">$ccdhost{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		
		<tr><td valign='top'><input type='radio' name='grp2' value='cust_grp_tgt' $checked{'grp2'}{'cust_grp_tgt'}></td><td >$Lang::tr{'fwhost cust grp'}</td><td><select name='cust_grp_tgt' style='min-width:185px;'>
END
		$helper='';
		foreach my $key (sort { uc($customgrp{$a}[0]) cmp uc($customgrp{$b}[0]) } keys %customgrp) {
			if($helper ne $customgrp{$key}[0]){
				print"<option ";
				print"selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq  $customgrp{$key}[0]);
				print">$customgrp{$key}[0]</option>";
			}
			$helper=$customgrp{$key}[0];
		}
		print<<END;
		</select></td>
		<td valign='top'><input type='radio' name='grp2' value='ipsec_host_tgt' $checked{'grp2'}{'ipsec_host_tgt'}></td><td >$Lang::tr{'fwhost ipsec host'}</td><td><select name='ipsec_host_tgt' style='min-width:185px;'>
END
		foreach my $key (sort { uc($ipsecconf{$a}[1]) cmp uc($ipsecconf{$b}[1]) } keys %ipsecconf) {
			if ($ipsecconf{$key}[3] eq 'host'){
				print"<option ";
				print"selected='Selected'" if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq $ipsecconf{$key}[1]);
				print">$ipsecconf{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		<tr><td colspan='3'></td><td valign='top'><input type='radio' name='grp2' value='ipsec_net_tgt' $checked{'grp2'}{'ipsec_net_tgt'}></td><td >$Lang::tr{'fwhost ipsec net'}</td><td><select name='ipsec_net_tgt' style='min-width:185px;'>
END
		foreach my $key (sort  { uc($ipsecconf{$a}[1]) cmp uc($ipsecconf{$b}[1]) } keys %ipsecconf) {
			if ($ipsecconf{$key}[3] eq 'net'){
				print"<option ";
				print"selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp2'}} eq $ipsecconf{$key}[1]);
				print">$ipsecconf{$key}[1]</option>";
			}
		}
		print<<END;
		</select></td></tr>
		</table>
		<b>$Lang::tr{'fwhost attention'}:</b><br>
		$Lang::tr{'fwhost macwarn'}<br><hr style='border:dotted #BFBFBF; border-width:1px 0 0 0 ; '></hr><br>
		
		<table width='100%' border='0'>
		<tr><td width='1%'><input type='checkbox' name='USESRV' value='ON' $checked{'USESRV'}{'ON'} ></td><td width='48%'>$Lang::tr{'fwdfw use srv'}</td><td width='1%'><input type='radio' name='grp3' value='cust_srv' checked></td><td nowrap='nowrap'>$Lang::tr{'fwhost cust service'}</td><td width='1%' colspan='2'><select name='cust_srv'style='min-width:230px;' >
END
		&General::readhasharray("$configsrv", \%customservice);
		foreach my $key (sort keys %customservice){
			print"<option ";
			print"selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp3'}} eq $customservice{$key}[0]);
			print">$customservice{$key}[0]</option>";
		}	
		print<<END;
		</select></td></tr>
		<tr><td colspan='2'></td><td><input type='radio' name='grp3' value='cust_srvgrp' $checked{'grp3'}{'cust_srvgrp'}></td><td nowrap='nowrap'>$Lang::tr{'fwhost cust srvgrp'}:</td><td colspan='2'><select name='cust_srvgrp'style='min-width:230px;' >
END
		&General::readhasharray("$configsrvgrp", \%customservicegrp);
		my $helper;
		foreach my $key (sort keys %customservicegrp){
			if ($helper ne $customservicegrp{$key}[0]){
				print"<option ";
				print"selected='selected'" if ($fwdfwsettings{$fwdfwsettings{'grp3'}} eq $customservicegrp{$key}[0]);
				print">$customservicegrp{$key}[0]</option>";
			}
			$helper=$customservicegrp{$key}[0];
		}	
		print<<END;
		</select></td></tr>
		<tr><td colspan='2'></td><td><input type='radio' name='grp3' value='TGT_PORT' $checked{'grp3'}{'TGT_PORT'}></td><td>$Lang::tr{'fwdfw man port'}</td><td><select name='TGT_PROT'>
END
		foreach ("TCP","UDP","GRE","ICMP")
		{
			if ($_ eq $fwdfwsettings{'TGT_PROT'})
			{
				print"<option selected>$_</option>";
			}else{
				print"<option>$_</option>";
			}
		}
		print<<END;
		</select></td><td align='right'><input type='text' name='TGT_PORT' value='$fwdfwsettings{'TGT_PORT'}' maxlength='11' size='9' ></td></tr>
		<tr><td colspan='2'></td><td></td><td>$Lang::tr{'fwhost icmptype'}</td><td colspan='2'><select name='ICMP_TGT'>
END
		&General::readhasharray("${General::swroot}/fwhosts/icmp-types", \%icmptypes);
		print"<option>All ICMP-Types</option>";
		foreach my $key (sort { uc($icmptypes{$a}[0]) cmp uc($icmptypes{$b}[0]) }keys %icmptypes){
			if($fwdfwsettings{'ICMP_TGT'} eq "$icmptypes{$key}[0] - $icmptypes{$key}[1]"){
				print"<option selected>$icmptypes{$key}[0] ($icmptypes{$key}[1])</option>";
			}else{
				print"<option>$icmptypes{$key}[0] ($icmptypes{$key}[1])</option>";
			}
		}
		print<<END;
		</select></td></tr>
		</table><hr><br><br>
		
END
		#---Activate/logging/remark-------------------------------------
		&Header::openbox('100%', 'left', $Lang::tr{'fwdfw additional'});
		print<<END;
		<table width='100%' border='0'>
		<tr><td colspan='2' >$Lang::tr{'remark'}:<input type='text' name='ruleremark' size='40' value='$fwdfwsettings{'ruleremark'}'></td></tr>
		<tr><td width='1%'><input type='checkbox' name='ACTIVE' value='ON' $checked{'ACTIVE'}{'ON'}></td><td>$Lang::tr{'fwdfw rule activate'}</td></tr>
		<tr><td width='1%'><input type='checkbox' name='LOG' value='ON'  $checked{'LOG'}{'ON'}  ></td><td>$Lang::tr{'fwdfw log rule'}</td></tr>
		</table><hr><br>
END
		&Header::closebox();
		#---ADD TIMEFRAME-----------------------------------------------
		&Header::openbox('100%', 'left', $Lang::tr{'fwdfw timeframe'});
		print<<END;
		<table width='70%' border='0'>
		<tr><td width='1%'><input type='checkbox' name='TIME' value='ON' $checked{'TIME'}{'ON'}></td><td colspan='4'>$Lang::tr{'fwdfw timeframe'}</td></tr>
		<tr><td colspan='7'>&nbsp</td></tr>
		<tr>
			<td  align='left'>$Lang::tr{'time'}:</td>
			<td width='30%' align='left'>$Lang::tr{'advproxy monday'} $Lang::tr{'advproxy tuesday'} $Lang::tr{'advproxy wednesday'} $Lang::tr{'advproxy thursday'} $Lang::tr{'advproxy friday'} $Lang::tr{'advproxy saturday'} $Lang::tr{'advproxy sunday'}</td>
			
			<td width='15%' align='left'>$Lang::tr{'advproxy from'}</td>
			<td width='15%' align='left'>$Lang::tr{'advproxy to'}</td>
		</tr>
		<tr>
			<td  align='right'></td>
			<td width='30%' align='left'>
				<input type='checkbox' name='TIME_MON' $checked{'TIME_MON'}{'on'} />
				<input type='checkbox' name='TIME_TUE' $checked{'TIME_TUE'}{'on'} />
				<input type='checkbox' name='TIME_WED' $checked{'TIME_WED'}{'on'} />
				<input type='checkbox' name='TIME_THU' $checked{'TIME_THU'}{'on'} />
				<input type='checkbox' name='TIME_FRI' $checked{'TIME_FRI'}{'on'} />
				<input type='checkbox' name='TIME_SAT' $checked{'TIME_SAT'}{'on'} />
				<input type='checkbox' name='TIME_SUN' $checked{'TIME_SUN'}{'on'} />
			</td>
			
			<td><select name='TIME_FROM'>
END
		for (my $i=0;$i<=23;$i++) {
			$i = sprintf("%02s",$i);
			for (my $j=0;$j<=45;$j+=15) {
				$j = sprintf("%02s",$j);
				my $time = $i.":".$j;
				print "\t\t\t\t\t<option $selected{'TIME_FROM'}{$time}>$i:$j</option>\n";
			}
		}
		print<<END;	
			</select></td>
			<td><select name='TIME_TO'>
END
		for (my $i=0;$i<=23;$i++) {
			$i = sprintf("%02s",$i);
			for (my $j=0;$j<=45;$j+=15) {
				$j = sprintf("%02s",$j);
				my $time = $i.":".$j;
				print "\t\t\t\t\t<option $selected{'TIME_TO'}{$time}>$i:$j</option>\n";
			}
		}
		print<<END;	
		</select></td></tr>
		</table><hr>
END
		&Header::closebox();
		#---ACTION------------------------------------------------------
		if($fwdfwsettings{'updatefwrule'} ne 'on'){
			print<<END;
			<table border='0' width='100%'>
			<tr><td align='right'><input type='submit' value='$Lang::tr{'add'}' style='min-width:100px;' /><input type='hidden' name='ACTION' value='saverule' ></form><form method='post' style='display:inline'><input type='submit' value='$Lang::tr{'fwhost back'}' style='min-width:100px;'><input type='hidden' name='ACTION' value'reset'></td></td>
			</table></form>
END
		}else{
			print<<END;
			<table border='0' width='100%'>
			<tr><td align='right'><input type='submit' value='$Lang::tr{'fwdfw change'}' style='min-width:100px;' /><input type='hidden' name='updatefwrule' value='$fwdfwsettings{'updatefwrule'}'><input type='hidden' name='key' value='$fwdfwsettings{'key'}'>
			<input type='hidden' name='oldgrp1a' value='$fwdfwsettings{'oldgrp1a'}' />
			<input type='hidden' name='oldgrp1b' value='$fwdfwsettings{'oldgrp1b'}' />
			<input type='hidden' name='oldgrp2a' value='$fwdfwsettings{'oldgrp2a'}' />
			<input type='hidden' name='oldgrp2b' value='$fwdfwsettings{'oldgrp2b'}' />
			<input type='hidden' name='oldgrp3a' value='$fwdfwsettings{'oldgrp3a'}' />
			<input type='hidden' name='oldgrp3b' value='$fwdfwsettings{'oldgrp3b'}' />
			
			
			<input type='hidden' name='ACTION' value='saverule' ></form><form method='post' style='display:inline'><input type='submit' value='$Lang::tr{'fwhost back'}' style='min-width:100px;'><input type='hidden' name='ACTION' value'reset'></td></td>
			
			</table></form>
END
		}
		&Header::closebox();
}
sub error
{
	if ($errormessage) {
		&Header::openbox('100%', 'left', $Lang::tr{'error messages'});
		print "<class name='base'>$errormessage\n";
		print "&nbsp;</class>\n";
		&Header::closebox();
		print"<hr>";
	}
}
sub setup_default_networks
{
	my %netsettings=();
	my $defaultNetworks = shift;
	
	&General::readhash("/var/ipfire/ethernet/settings", \%netsettings);
	
	# Get current defined networks (Red, Green, Blue, Orange)
	$defaultNetworks->{$Lang::tr{'fwhost any'}}{'IPT'} = "0.0.0.0/0.0.0.0";
	
		
	$defaultNetworks->{$Lang::tr{'fwhost green'}}{'IPT'} = "$netsettings{'GREEN_NETADDRESS'}/$netsettings{'GREEN_NETMASK'}";
	

	if ($netsettings{'ORANGE_DEV'} ne ''){
		$defaultNetworks->{$Lang::tr{'fwhost orange'}}{'IPT'} = "$netsettings{'ORANGE_NETADDRESS'}/$netsettings{'ORANGE_NETMASK'}";
	}

	if ($netsettings{'BLUE_DEV'} ne ''){
		$defaultNetworks->{$Lang::tr{'fwhost blue'}}{'IPT'} = "$netsettings{'BLUE_NETADDRESS'}/$netsettings{'BLUE_NETMASK'}";
	}

	# OpenVPN
	if(-e "${General::swroot}/ovpn/settings")
	{
		my %ovpnSettings = ();
		&General::readhash("${General::swroot}/ovpn/settings", \%ovpnSettings);

		# OpenVPN on Red?
		if(defined($ovpnSettings{'DOVPN_SUBNET'}))
		{
			my ($ip,$sub) = split(/\//,$ovpnSettings{'DOVPN_SUBNET'});
			$sub=&General::iporsubtocidr($sub);
			my @tempovpnsubnet = split("\/", $ovpnSettings{'DOVPN_SUBNET'});
			$defaultNetworks->{'OpenVPN ' .$ip."/".$sub}{'ADR'} = $tempovpnsubnet[0];
		}
	} # end OpenVPN

	open(FILE, "${General::swroot}/ethernet/aliases") or die 'Unable to open aliases file.';
	my @current = <FILE>;
	close(FILE);
	my $ctr = 0;
	foreach my $line (@current)
	{
		if ($line ne ''){
			chomp($line);
			my @temp = split(/\,/,$line);
			if ($temp[2] eq '') {
				$temp[2] = "Alias $ctr : $temp[0]";
			}
			$defaultNetworks->{$temp[2]}{'IPT'} = "$temp[0]";
			$ctr++;
		}
	}
}
sub validremark
{
	# Checks a hostname against RFC1035
        my $remark = $_[0];

	# Each part should be at least two characters in length
	# but no more than 63 characters
	if (length ($remark) < 1 || length ($remark) > 63) {
		return 0;}
	# Only valid characters are a-z, A-Z, 0-9 and -
	if ($remark !~ /^[a-zäöüA-ZÖÄÜ0-9-\s]*$/) {
		return 0;}
	# First character can only be a letter or a digit
	if (substr ($remark, 0, 1) !~ /^[a-zäöüA-ZÖÄÜ0-9]*$/) {
		return 0;}
	# Last character can only be a letter or a digit
	if (substr ($remark, -1, 1) !~ /^[a-zöäüA-ZÖÄÜ0-9]*$/) {
		return 0;}
	return 1;
}
sub getsrcport
{
	my %hash=%{(shift)};
	my $key=shift;
	if($hash{$key}[7] eq 'ON' && $hash{$key}[8] ne 'ICMP'){
		print" : ($hash{$key}[8]) $hash{$key}[10]";
	}elsif($hash{$key}[7] eq 'ON' && $hash{$key}[8] eq 'ICMP'){
		print" : ($hash{$key}[8]) <br> $hash{$key}[9]";
	}
}
sub gettgtport
{
	my %hash=%{(shift)};
	my $key=shift;
	my $service;
	my $prot;
	
	if($hash{$key}[11] eq 'ON' && $hash{$key}[12] ne 'ICMP'){
		if($hash{$key}[14] eq 'cust_srv'){
			&General::readhasharray("$configsrv", \%customservice);
			foreach my $i (sort keys %customservice){
				if($customservice{$i}[0] eq $hash{$key}[15]){
					$prot = $hash{$key}[12];
					$service = $customservice{$i}[0];
				}
			}
		}elsif($hash{$key}[14] eq 'cust_srvgrp'){
			
			$service=$hash{$key}[15];
		}elsif($hash{$key}[14] eq 'TGT_PORT'){
			$service=$hash{$key}[15];
			$prot=$hash{$key}[12];
		}
	}elsif($hash{$key}[11] eq 'ON' && $hash{$key}[12] eq 'ICMP'){
		print" : ($hash{$key}[12]) <br>$hash{$key}[13]";
	}
	
	if ($prot ne '' || $service ne ''){
		print" :";
		if ($prot ne ''){
			print"($prot) ";
		}
		print" $service";
	}
}
sub viewtablerule
{
	if ( ! -z "$configfwdfw"){
		&Header::openbox('100%', 'left', $Lang::tr{'fwdfw rules'});
		my $count=0;
		my ($gif,$log);
		my $ruletype;
		my $rulecolor;
		my $tooltip;
		&General::readhasharray("$configfwdfw", \%configfwdfw);
		print"<table width='100%' border='0' cellspacing='1' >";
		print"<tr><td align='center' width='1%'><b>#</td><td width='1%'></td><td align='center'><b>$Lang::tr{'fwdfw source'}</td><td><b>LOG</td><td align='center'><b>$Lang::tr{'fwdfw target'}</td><td align='center'><b>$Lang::tr{'remark'}</td><td align='center' colspan='3'><b>$Lang::tr{'fwdfw action'}</td></tr>";
		foreach my $key (sort keys %configfwdfw){
			$configfwdfw{'ACTIVE'}=$configfwdfw{$key}[2];
			$count++;
			print"<tr bgcolor='$color{'color18'}'><td colspan='10'></td></tr>";
			if ($count % 2){ print"<tr bgcolor='$color{'color22'}' >";}else{print"<tr bgcolor='$color{'color20'}' >";}
			print<<END;
			<td align='right'>$key</td>
END
			if ($configfwdfw{$key}[0] eq 'ACCEPT'){
				$ruletype='A';
				$tooltip='ACCEPT';
				$rulecolor=$color{'color17'};
			}elsif($configfwdfw{$key}[0] eq 'DROP'){
				$ruletype='D';
				$tooltip='DROP';
				$rulecolor=$color{'color25'};
			}elsif($configfwdfw{$key}[0] eq 'REJECT'){
				$ruletype='R';
				$tooltip='REJECT';
				$rulecolor=$color{'color16'};
			}
			print"<td bgcolor='$rulecolor' width='2%' align='center'><span title='$tooltip'><b>$ruletype</b></span></td>";
			print"<td align='center'>$configfwdfw{$key}[4]";

			&getsrcport(\%configfwdfw,$key);
			if ($configfwdfw{$key}[17] eq 'ON'){
				$log="/images/on.gif";
			}else{
				$log="/images/off.gif";
			}
			print<<END;
			</td>
			
			<form method='post'>
			<td width='1%' ><input type='image' img src='$log' alt='$Lang::tr{'click to disable'}' title='$Lang::tr{'fwdfw togglelog'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;'/>
			<input type='hidden' name='key' value='$key' />
			<input type='hidden' name='ACTION' value='$Lang::tr{'fwdfw togglelog'}' />
			</td></form>
END
		
			print<<END;
			<td align='center'>$configfwdfw{$key}[6]
END
			&gettgtport(\%configfwdfw,$key);

			print"</td><td width='20%'>$configfwdfw{$key}[16]</td>";
			
			if($configfwdfw{$key}[2] eq 'ON'){
				$gif="/images/on.gif"
				
			}else{
				$gif="/images/off.gif"
				
			}
			print<<END;
			<form method='post'>
			<td width='1%'><input type='image' img src='$gif' alt='$Lang::tr{'click to disable'}' title='$Lang::tr{'fwdfw toggle'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;' />
			<input type='hidden' name='key' value='$key' />
			<input type='hidden' name='ACTION' value='$Lang::tr{'fwdfw toggle'}' />
			</td></form>
			
			<form method='post'>
			<td  width='1%' ><input type='image' img src='/images/edit.gif' alt='$Lang::tr{'edit'}' title='$Lang::tr{'fwdfw edit'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;'  />
			<input type='hidden' name='key' value='$key' />
			<input type='hidden' name='ACTION' value='editrule' />
			</td></form></td>
			
			<form method='post'>
			<td  width='1%'><input type='image' img src='/images/addblue.gif' alt='$Lang::tr{'fwdfw copy'}' title='$Lang::tr{'fwdfw copy'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;' />
			<input type='hidden' name='key' value='$key' />
			<input type='hidden' name='ACTION' value='copyrule' />
			</td></form></td>
			
			
			<form method='post'>
			<td width='1%' ><input type='image' img src='/images/delete.gif' alt='$Lang::tr{'delete'}' title='$Lang::tr{'fwdfw delete'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;'   />
			<input type='hidden' name='key' value='$key' />
			<input type='hidden' name='ACTION' value='deleterule' />
			</td></form></td>
END
			if (exists $configfwdfw{$key-1}){
				print<<END;
				<form method='post'>
				<td width='1%'><input type='image' img src='/images/up.gif' alt='$Lang::tr{'fwdfw moveup'}' title='$Lang::tr{'fwdfw moveup'}'  style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;'  />
				<input type='hidden' name='key' value='$key' />
				<input type='hidden' name='ACTION' value='moveup' />
				</td></form></td>
END
			}else{
				print"<td></td>";
			}
		
			if (exists $configfwdfw{$key+1}){
				print<<END;
				<form method='post'>
				<td  width='1%' ><input type='image' img src='/images/down.gif' alt='$Lang::tr{'fwdfw movedown'}' title='$Lang::tr{'fwdfw movedown'}' style='padding-top: 0px; padding-left: 0px; padding-bottom: 0px ;padding-right: 0px ;display: block;'  />
				<input type='hidden' name='key' value='$key' />
				<input type='hidden' name='ACTION' value='movedown' />
				</td></form></td></tr>
END
			}else{
				print"<td></td></tr>";
			}
			
				
		}
		print"</table>";
		&Header::closebox();
	}
	
	
}
sub fillselect
{
	my %hash=%{(shift)};
	my $val=shift;
	my $key;
	foreach my $key (sort { uc($hash{$a}[0]) cmp uc($hash{$b}[0]) }  keys %hash)
		{
			if($hash{$key}[0] eq $val){
				print"<option value='$hash{$key}[0]' selected>$hash{$key}[0]</option>";
			}else{
				print"<option value='$hash{$key}[0]'>$hash{$key}[0]</option>";
			}
		}
}
&Header::closebigbox();
&Header::closepage();
